# calling first encode_XOR_charlist64_getIPHRs then append tmp_iphrArray to iphrArray
encode_charlist64(){
	encode_c64_str_to_array "$unencoded_IPHR_input" || return 1
	
	! encode_charlist64_getIPHRs 0 0  \
		&& debugMsg "error returned from 'encode_XOR_charlist64_getIPHRs()'"   \
		&& return 1
	! addIPHRto_iphrArray   \
		&& debugMsg "error returned from 'addIPHRto_iphrArray()'"   \
		&& return 1
	
	show_XOR_key || return 1
	
	return 0
}
encode_XOR_charlist64(){
	encode_c64_str_to_array "$unencoded_IPHR_input" || return 1
	generate_XORarr_key ${#c64_encoded_arr[@]} || return 1
	xor_two_arrays c64_encoded_arr XORarray_key || return 1
	
	! encode_XOR_charlist64_getIPHRs 0 0  \
		&& debugMsg "error returned from 'encode_XOR_charlist64_getIPHRs()'"   \
		&& return 1
	! addIPHRto_iphrArray   \
		&& debugMsg "error returned from 'addIPHRto_iphrArray()'"   \
		&& return 1
	
	show_XOR_key || return 1
	
	return 0
}

encode_charlist64_getIPHRs(){
	p_message "method 'encode_charlist64_getIPHRs' not yet done" ; return 1

	return 0
}

encode_XOR_charlist64_getIPHRs(){
	# check valid arguments
	! [[ $1 == [0-1] ]] && p_err "isSubsequentIPHR wrong format '$1'" && return 2
	! [[ $2 == +([0-9]) ]] && p_err "index XORed_arr invalid: '$2'"  && return 2
	i_XORed_arr=$2

	sbsqtKID=0
	isSubsequentIPHR=$1  # Bit 2 of Settings Word
	methodBits=0x01 # XOR_charlist64 Method has Method ID '0x01' ; Bits 3-6 of Settings Word
	
	hexadesIPHR=() # empty array from previous calls or
	               # decoding calls of 'fillArr_hexadesIPHR()'
	               # (for interactive mode)
	# init elememt 1 of arr with placeholder that index points correctly to 2nd element
	hexadesIPHR[0]=0 # placeholder for Settings Word
	                 # length word is omitted, since NULL terminated string

	for(( ; i_XORed_arr<${#XORed_arr[@]} & ${#hexadesIPHR[@]}<24 ; i_XORed_arr++ )); do
		hexadesIPHR[${#hexadesIPHR[@]}]=${XORed_arr[i_XORed_arr]}
	done
	if (( ${#XORed_arr[@]} > i_XORed_arr )); then
		sbsqtKID=1
	fi
	debugMsg "i_XORed_arr: $i_XORed_arr"  \
	         "#XORed_arr: ${#XORed_arr[@]}" \
	         "hexadesIPHR (len: ${#hexadesIPHR[@]}):"   \
		     "'$(echo "${hexadesIPHR[@]}")'"
	transform_hexadesIPHR_to_hex_iphr || return 1

	# if subsequent key needed, recurse:
	if (( sbsqtKID )); then
		encode_XOR_charlist64_getIPHRs 1 $i_XORed_arr || return 1
	fi

	return 0
}

show_XOR_key(){
	base64_encode_hexades XORarray_key || return 1
	local i

	crc16="$(
		$crc16_nk "$(printf "%s" ${b64_converted_arr[@]:0:c64ArrLen})" \
			| xxd -r -p  \
			| base64
	)"
	crc16=${crc16:0:3}
	debugMsg "crc16: '$crc16'"
	
	debugMsg "b64_converted_arr:" "$(printf "%s" ${b64_converted_arr[@]})"

	echo
	echo "***** NOTE XOR KEY FOR DECRYPTION *****"
	echo
	# echo "   octal:"
	# printf "        "
	# printf "%02o " "${XORarray_key[@]:0:c64ArrLen}"; echo
	# echo
	echo "   $(
		for((i=0; i<c64ArrLen; i++)); do
			printf "%s" ${b64_converted_arr[i]}
			(( (i+1)%4 == 0 )) && printf " "
		done) $crc16"
	echo
	# echo "(length: $c64ArrLen)"
	echo "***************************************"
	echo "(This key is needed for decoding!)"
	echo

	echo "(type 'ok' to erase screen and continue)"
	answer="" ; while [[ "$answer" != "ok" ]]; do
		read answer
		printf "\033[1A\033[2K"
	done
	for i in {0..7}; do printf "\033[1A\033[2K"; done
	
	return 0
}

b64_converted_arr=()
base64_encode_hexades(){
	local -n input_arr=$1
	b64_converted_arr=()
	local i
	for((i=0; i<${#input_arr[@]}; i++)); do
		b64_converted_arr[i]=${base64_charset[${input_arr[i]}]}
	done
	return 0
}

XORarray_key=()
generate_XORarr_key(){
	debugMsg "in $FUNCNAME"
	[[ -z $1 ]] && p_err "no length given" && return 1
	len=$1
	XORarray_key=( $(
		printf "%d " $(
			openssl rand -hex $len  \
				| awk '{
					for(i=1;i<length($1); i+=2){
						printf "0x%s ", substr($1, i, 2)
					} print ""
				}'
		)
	) )
	local i
	for((i=0;i<${#XORarray_key[@]};i++)); do
		XORarray_key[i]=$(( ${XORarray_key[i]} & 0x3f ))
	done
	# debugMsg "XORarray_key:" "$(printf "%02x " "${XORarray_key[@]}")"
	return 0
}

c64_encoded_arr=()
encode_c64_str_to_array(){
	[[ -z $1 ]] \
		&& p_err "no argument given" "usage: $FUNCNAME <utf8_string_var> [--print-b64]" \
		         "result in '\$c64_encoded_arr'" \
		&& return 1
	utf8_string="$1"
	# check terminal encoding to use UTF-8 chars
	if ! locale charmap | grep -q -i -e "UTF-8" -e "utf8"; then
		p_err "Terminal needs to be in UTF-8 encoding mode."
		return 1
	fi
	c64_encoded_arr=()
	local i j=0
	for((i=0; i<${#utf8_string}; i++)); do
		idx=1
		while [[ "${utf8_string:$i:1}" != "${charlist64_1[idx]}" ]] \
		&& (( idx<63  ));do
			(( idx++ ))
		done
		# if match in table 1 (charlist64_1)
		if (( idx<62 )); then
			c64_encoded_arr[i+j]=$idx
		else # look for match in table 2 (charlist64_2)
			idx=0
			while [[ "${utf8_string:$i:1}" != "${charlist64_2[idx]}" ]] \
			&& (( idx<${#charlist64_2[@]} ));do
				(( idx++ ))
			done
			#debugMsg "charlist64_2 idx $idx: '${charlist64_2[idx]}'"
			if (( idx<${#charlist64_2[@]} )); then
				c64_encoded_arr[i+j]=62
				((j++))
				c64_encoded_arr[i+j]=$idx
			fi
		fi
		# if still no match, use utf8 encoding
		if (( idx > 63 ));then
			c64_encoded_arr[i+j]=63
			encode_utf8_octet_to_hexade $i $j || return 1
		fi
	done
	c64_encoded_arr[${#c64_encoded_arr[@]}]=0  # terminate string
	c64ArrLen=${#c64_encoded_arr[@]}

	# create base64 representation if option is set
	if [[ "$2" == "--print-b64" ]]; then
		mpm_enc_arr=()
		for((i=0; i<${#c64_encoded_arr[@]}; i++)); do
			mpm_enc_arr+=( "${base64_charset[${c64_encoded_arr[i]}]}" )
		done
		# padd with '=' signs (and an 'A' for '0o00' if neccessary)
		if (( ${#mpm_enc_arr[@]} % 4 == 1 )); then
			mpm_enc_arr[${#mpm_enc_arr[@]}]="A"
		fi
		while (( ${#mpm_enc_arr[@]} % 4 != 0 )); do
			mpm_enc_arr[${#mpm_enc_arr[@]}]="="
		done
		printf "'\$mpm_enc_arr' is:\n"
		for((i=0; i<${#mpm_enc_arr[@]}; i++)); do
			printf "%s" ${mpm_enc_arr[i]}
		done
		echo
	fi

	# add padding
	paddingWord=$(( 23 - ( c64ArrLen%23 ) )) # 23 words (hexades) available for method (per hexadesIPHR)
	if (( paddingWord != 23 )); then
		for((i=c64ArrLen; i < c64ArrLen+paddingWord; i++)); do
			c64_encoded_arr[${#c64_encoded_arr[@]}]=$paddingWord
		done
	fi

	debugMsg "paddingWord: '$paddingWord' c64ArrLen: '$c64ArrLen' c64_encoded_arr:" "oct: $(printf "%02o " ${c64_encoded_arr[@]})" "dez: $(printf "%02d " ${c64_encoded_arr[@]})"
	return 0
}
encode_utf8_octet_to_hexade(){
	# utf8 encoding/decoding.
	# 
	# Omit leading two Bits of all UTF-8 bytes, since starting Byte is *always*
	# 		11bb bbbb
	# and following bytes are *always*
	# 		10bb bbbb
	# Count the '1' bits of the starting byte before the first '0' bit *after* leading
	# '11' bits, to get the total byte count.
	# E.g.:
	# 		(11) 0b bbbb    is a 2-bytes UTF-8 char
	# 		(11) 10 bbbb    is a 3-bytes UTF-8 char
	# 		(11) 11 0bbb    is a 4-bytes UTF-8 char
	# Two byte example:
	#		å  ->  0xc3a5
	#		1100 0011  1010 0101
	#		encodes to hexades:
	#		--00 0011  --10 0101 = 000 011  100 101 = 0o 03 45
	#		full encoding with starting hexade (63 = 0o77):
	#		111 111  000 011  100 101
	#		0o 77 03 45
	# Three byte example:
	#		Ⓐ  ->  0xe292b6
	#		1110 0010  1001 0010  1011 0110
	#		encodes to hexades:
	#		--10 0010  --01 0010  --11 0110
	#		= 100 010  010 010  110 110 = 0o 42 22 66
	#		full encoding with starting hexade (63 = 0o77):
	#		0o 77 42 22 66
	# Four byte example:
	#		🤣  ->  0xf09fa4a3
	#		1111 0000  1001 1111  1010 0100  1010 0011
	#		encodes to hexades:
	#		--11 0000  --01 1111  --10 0100  --10 0011
	#		= 110 000  011 111  100 100  100 011 = 0o 60 37 44 43
	#		full encoding with starting hexade (63 = 0o77):
	#		0o 77 60 37 44 43

	[[ -z $2 ]] && p_err "arguments missing" && return 1
	i=$1 j=$2 # c64_encoded_arr index counters
	utf8_char=${utf8_string:$i:1}
	hex_utf8=0x$(printf "$utf8_char" | xxd -p)
	debugMsg "hex_utf8: $hex_utf8"
	utf8_startBits=$(( 0x${hex_utf8:2:2} & 0xc0 ))
	if (( utf8_startBits != 0xc0 )); then
		debugMsg "not a multibyte UTF-8 char '$utf8_char'"
		encode_ascii_ctrl_seq_to_invalid_utf8hexades $i $j || return 1
		return 0
	fi
	byte_count=2; utf8_hexad_startBits=$(( 0x${hex_utf8:2:2} & 0x3f ))
	while (( utf8_hexad_startBits & 0x20 )); do
		utf8_hexad_startBits=$(( utf8_hexad_startBits << 1 ))
		(( byte_count++ ))
		(( byte_count > 4 )) && p_err "char '${utf8_string:$i:1}' no valid utf8. byte count bigger 4" && return 1
	done
	utf8idx=2 ; next_c64ArrLen=$(( i + j + byte_count ))
	while (( j<next_c64ArrLen-i )); do
		(( j++ ))
		c64_encoded_arr[i+j]=$(( 0x${hex_utf8:utf8idx:2} & 0x3f ))
		(( utf8idx += 2 ))
	done
	return 0
}
encode_ascii_ctrl_seq_to_invalid_utf8hexades(){
	[[ -z $2 ]] && p_err "arguments missing" && return 1
	
	debugMsg "$(declare -p c64_encoded_arr)"
	((j++))
	c64_encoded_arr[i+j]=$(( ( ${hex_utf8} & 0xc0 ) >> 6 ))
	((j++))
	c64_encoded_arr[i+j]=$(( ( ${hex_utf8} & 0x3f ) >> 0 ))
	debugMsg "$(declare -p c64_encoded_arr)"

	return 0
}
