# fills array 'decodedDates' with days and chars.
decodedDates=()
decIPHRdateMethod(){
	debugMsg "[BEGIN $FUNCNAME]"
	# get decIPHRdateMethod specific decoded lenght
	local i=0; local len=6; local j=0
	while (( ( ${hexadesIPHR[1]} >> i ) & 0x01 == 1 )); do
		(( len-- ))
		(( i++ ))
	done
	(( len == 0 )) && p_err "invalid length" && return 1
	debugMsg "length: $len" "$(printf "%02x" ${hexadesIPHR[1]} | xxd -p -r | xxd -b)"
	
	# decode Indirect Key
	decodedDataLen=2 # decoded so far are hexades 0 and 1 (settings, length)
	for (( i=0; i<len; i++ )); do
		#  block size is 24 hexades (24 6 Bit words)
		(( decodedDataLen>24 )) && p_err "invalid IPHR. Length exceeded." && return 1
		if (( ( ${hexadesIPHR[1]} >> (5-i) ) & 0x01 == 1 )); then
		# if: hexadesIPHR element is a date (current len Bit is '1')
			# date is encoded as 4 hexades (3 Bytes: 2 Bytes date, 1 Byte word number)
			encDate=0 # erase old value
			for((j=decodedDataLen; j<decodedDataLen+4; j++)); do
				(( j>=24 )) && p_err "invalid IPHR. Length encoding corrupted." && return 1
				encDate=$(( (encDate << 6) | ${hexadesIPHR[$j]} ))
			done
			# to decode hex date get only first 2 Bytes
			decodeHexDate "$(printf "%04x" $((encDate >> 8)) )"
			encWordNum=$((encDate & 0xff)) # encoded word number is 3rd Byte
			(( encWordNum > 127 )) && (( encWordNum-=256 )) # transform to 1 Byte signed int

			# done. add decoded dates to array
			decodedDates[${#decodedDates[@]}]="$(printf "$decodedDate word $encWordNum\n")"
			(( decodedDataLen+=4 ))
			
			debugMsg "$(printf "hexadesIPHR[$((j-4))-$((j-1))]: '0o%02o%02o%02o%02o'\n" \
				${hexadesIPHR[@]:$j-4:4})" "$(printf "encDate 0x%06x\n" $encDate)"
		else
		# else: hexadesIPHR element is a char
			# get next hexade until end of block size or until string terminating NULL hexade
			while (( decodedDataLen<24 )) && (( ${hexadesIPHR[$decodedDataLen]} != 0 ));do
				decodedDates[${#decodedDates[@]}]="$(printf "char ${hexadesIPHR[$decodedDataLen]}")"
				(( decodedDataLen+=1 ))
			done
			# skip string terminating NULL hexade
			(( decodedDataLen+=1 ))
		fi
	done

	debugMsg "[END $FUNCNAME]"
	return 0
}
