# decode Indirect Passphrase (IPHR) from keyDB by given '$1' (KeyID)
keysCounter=0
decodeIPHR(){
	debugMsg "BEGIN $FUNCNAME"
	sbsqtKID=2 # decode while there is the subsequent KeyID flag set
	local i=0
	keysCounter=0
	decodedDates=() # clear array if it has been filled in interactive mode
	(( ${#iphrArray[@]} > 400 & keyID > 400 ))                 \
		&& echo "Large iphrArray. Blocks: ${#iphrArray[@]}"  \
		&& echo "Parsing..."
	for (( i=0; sbsqtKID==1 | ( (keysCounter<=keyID) & (i<${#iphrArray[@]}) ) ; i++ )); do
		iphr=${iphrArray[$i]}
		! fillArr_hexadesIPHR $iphr && p_err "i '$i' iphrArray:" "${iphrArray[@]}" && return 1

		sbsqtKID=$((         ( ${hexadesIPHR[0]} & 0x20 ) >> 5 ))
		isSubsequentIPHR=$(( ( ${hexadesIPHR[0]} & 0x10 ) >> 4 ))
		methodBits=$((       ( ${hexadesIPHR[0]} & 0x0f ) >> 0 ))
		if (( isSubsequentIPHR==0 )); then
			(( keysCounter++ ))
		fi
		# debugMsg "isSubsequentIPHR: '$isSubsequentIPHR' sbsqtKID: '$sbsqtKID' keysCounter '$keysCounter' --- keyID '$keyID'"   \
		#          "iphrArray[$i]:" \
		#          "$(printf "%s" ${iphrArray[$i]})"

		(( !directDecode & keysCounter <= keyID )) && continue
		debug_print_hexadesIPHR

		# decode IndirectKey with specified method
		if (( methodBits == 0 )); then
			decIPHRdateMethod || return 1
		elif (( methodBits == 1 ));then
			decode_XOR_charlist64 || return 1
		else
			p_message "Method $methodBits not defined"
			return 1
		fi

		if (( directDecode & (sbsqtKID|isSubsequentIPHR) )); then
			(( keysCounter++ ))
			ask_for_continuation || return 1
		fi
	done
	(( keysCounter <= keyID )) && return 0 # given keyID is not in array
	
	print_result || return 1

	debugMsg "END $FUNCNAME"
	return 0
}
ask_for_continuation(){
	printf "\nOnly a part of Indirect Passphrase. "
	(( isSubsequentIPHR )) &&   \
		printf "Beginning is missing (isSubsequentIPHR==1). "
	(( sbsqtKID )) &&   \
		printf "End is missing. (sbsqtKID==1)."
	printf "\nContinue? (y/n) "
	read -n 1 answer
	echo
	[[ "$answer" != "y" ]] && return 0
	sbsqtKID=0
	echo
	printf "[Only part]\n"
	return 0
}
print_result(){
	if (( methodBits == 0 )); then
		echo "Date / charlist64 Method"
		echo "------------------------"
		printf "%s\n" "${decodedDates[@]}"
		echo "------------------------"
	elif (( methodBits == 1 ));then
		echo "Passphrase"
		echo "-----------"
		printf "%s\n" "${decoded_c64_string}"
		echo "-----------"

		echo "(hit 'e' to erase output screen and continue)"
		answer="" ; for((i=10;i>0;i--)); do
			printf "\rerase screen in %d (hit any other key to add 20 seconds)" $i
			read -n 1 -t 1 answer
			[[ "$answer" == "e" ]] && break
			[[ "$answer" != "" ]] && i=20
		done
		printf "\r\033[2K"
		for i in {0..5}; do printf "\033[1A\033[2K"; done # delete lines above

	else
		p_err "Method $methodBits not defined"
		return 1
	fi
	return 0
}
