readToEncode(){
	## check if data was given through stdin an refuse
	# not yet working
	#if [ -t 0 ]; then
	#	echo
	#	debugMsg "stdin_data: '$stdin_data'"
	#	p_message "[WARNING]" "Do not give your data through standard input."  \
	#	     "Considered insecure, because commandline input will be visible in history file."
	#	return 1
	#fi
	if [[ "$1" == "silent" ]]; then
		IFS= read -rs unencoded_IPHR_input < /dev/tty
	else
		# get input only from terminal not stdin
		read unencoded_IPHR_input < /dev/tty
	fi
	echo
	if [[ "$1" == "silent" ]]; then
		printf "confirm input: "
		IFS= read -rs input_confirm < /dev/tty
		echo
		local tries=0 fail=0
		while [[ "$input_confirm" != "$unencoded_IPHR_input" ]]; do
			(( tries > 2 )) && fail=1 && break
			(( tries++ ))
			printf "input didn't match. Try again: "
			IFS= read -rs unencoded_IPHR_input < /dev/tty
			echo
			printf "confirm input: "
			IFS= read -rs input_confirm < /dev/tty
			echo
		done
		(( fail )) && echo "input not matching." && return 1
	fi
	[ -z "$unencoded_IPHR_input" ] && p_message "Nothing given to encode." && return 1
	return 0
}

encode_IPHR_input(){
	tmp_iphrArray=()

	if (( encMethod == 0 )); then # Date Method
		printf "Type dates/chars to encode: "
		readToEncode || return 1
		encode_dateMethod || return 1
	elif (( encMethod == 1 )); then # XOR_charlist64
		printf "Type passphrase to XOR encode: "
		readToEncode "silent" || return 1
		encode_XOR_charlist64 || return 1
	elif (( encMethod == 2 )); then # charlist64
		printf "Type passphrase to XOR encode: "
		readToEncode "silent" || return 1
		encode_XOR_charlist64 || return 1
	else
		p_message "method '$encMethod' not defined"
		return 1
	fi
	echo ""

	assignmentKeysCounter=$(( $(echo "$keysAssignmentList" | wc -l) ))
	printf "Key assignment:\n"
	read assignmentInput
	while [[ "$assignmentInput" == "" ]]; do
		echo "Empty input. Need a key assignment:"
		read assignmentInput
	done
	keysAssignmentList=$(
		printf "$keysAssignmentList\n"
		printf "KeyID %03d: $assignmentInput\n" $assignmentKeysCounter
	)
	write_keyDB

	return 0
}

# append new encoded IPHR block(s) to IPHR array
addIPHRto_iphrArray(){
	if (( ! iphrArray_isDecrypted )); then
		! decrypt_iphrArrayDB && return 1
	fi
	iphrArray=( ${iphrArray[@]} ${tmp_iphrArray[@]} )
	return 0
}

# write settings to hexadesIPHR, converts to hex iphr; adds to tmp_iphrArray
transform_hexadesIPHR_to_hex_iphr(){
	if (( ${#hexadesIPHR[@]} > 24 )); then
		p_err "hexadesIPHR has wrong length (${#hexadesIPHR[@]}):"   \
		      "'$(echo "${hexadesIPHR[@]}")'"
		return 1
	fi

	# add padding
	if (( ${#hexadesIPHR[@]} < 24 )); then
		paddingWord=$(( 24 - ${#hexadesIPHR[@]} ))
	fi
	for (( i=${#hexadesIPHR[@]}; i<24; i++ )); do
		hexadesIPHR[${#hexadesIPHR[@]}]=$paddingWord
	done

	# set settings bits.
	(( hexadesIPHR[0] = ( sbsqtKID         << 5 ) | 0x0               ))
	(( hexadesIPHR[0] = ( isSubsequentIPHR << 4 ) | ${hexadesIPHR[0]} ))
	(( hexadesIPHR[0] = ( methodBits       << 0 ) | ${hexadesIPHR[0]} ))
	
	debug_print_hexadesIPHR

	# build 36 hex char IPHR from hexadesIPHR array
	iphr="" ; quadword=""
	for((i=0; i<24; i+=4)); do
		quadword=$((
			( hexadesIPHR[i+0] << 18 ) |
			( hexadesIPHR[i+1] << 12 ) |
			( hexadesIPHR[i+2] << 6  ) |
			( hexadesIPHR[i+3] << 0  )
		))
		iphr+=$(printf "%06x" $quadword)
	done

	debugMsg "iphr is:" "$iphr"
	
	tmp_iphrArray[${#tmp_iphrArray[@]}]=$iphr
	
	return 0
}
