# Fills array 'hexadesIPHR' with reformatted 18 Byte hex IPHR
# string (36 hex chars) to 24 6 Bit words (hexades/sixtetts) (48 oct chars)
declare -a hexadesIPHR=()
fillArr_hexadesIPHR(){
	hexadesIPHR=() # empty array from previous calls
	! checkHex $1 && p_err "Input was not a hex number." && return 2
	! checkArgLen $1 36 && p_err "Input was not 18 byte." && return 2
	# Indirect Passphrase
	local i=0
	for (( i=0; i<6; i++)); do # 6 rounds. get 3 bytes - 4 hexades - at once
		quadword=$(( 0x${iphr:$((i*6)):6} ))
		# p_err "$(nkhextobin $quadword -q) $quadword" "[debug] "
		for (( j=0; j<4; j++ )); do
			hexadesIPHR[${#hexadesIPHR[@]}]=$(( ( $quadword >> (6*(3-j)) ) & 0x3f ))
		done
		# p_err "$(printf "0o%02o%02o%02o%02o" \
		# 				${hexadesIPHR[$(( 0+(i*24/3) ))]}	\
		# 				${hexadesIPHR[$(( 1+(i*24/3) ))]}	\
		# 				${hexadesIPHR[$(( 2+(i*24/3) ))]}	\
		# 				${hexadesIPHR[$(( 3+(i*24/3) ))]}	
		# 			)" "[debug hexades] "
	done
	return 0
}
