mpm_encode_to_b64(){
	! declare -F p_err 1>/dev/null && echo "function 'p_err' not sourced." >&2 && return 1
	[[ $1 == "" ]] && p_err "no input string" && return 1
	(( ${#charlist64_1_v2[@]} < 64 )) && p_err "charlist64-arrays not defined" && return 1
	input_str="$1"
	mpm_enc_arr=()
	for((i=0; i<${#input_str}; i++)); do
		j=0
		while [[ "${input_str:i:1}" != "${charlist64_1_v2[j]}" ]] && (( j < 62 )); do
			((j++))
		done
		if (( j < 62 )); then
			mpm_enc_arr[${#mpm_enc_arr[@]}]=${base64_charset[j]}
		elif (( j == 62 )); then
			mpm_enc_arr[${#mpm_enc_arr[@]}]=${base64_charset[62]}
			j=0
			while [[ "${input_str:i:1}" != "${charlist64_2_v2[j]}" ]] && (( j<64 )); do
				((j++))
			done
			mpm_enc_arr[${#mpm_enc_arr[@]}]=${base64_charset[j]}
		else
			p_err "not in arr '${input_str:i:1}'"
			return 1
		fi
		(( j == 64 )) \
			&& printf "?"
	done
	if (( ${#mpm_enc_arr[@]} % 4 == 1 )); then
		mpm_enc_arr[${#mpm_enc_arr[@]}]="A"
	fi
	while (( ${#mpm_enc_arr[@]} % 4 != 0 )); do
		mpm_enc_arr[${#mpm_enc_arr[@]}]="="
	done
	printf "%s" "${mpm_enc_arr[@]}"
	printf "\n"
	return 0
}

mpm_decode_from_b64(){
	! declare -F p_err 1>/dev/null && echo "function 'p_err' not sourced." >&2 && return 1
	[[ $1 == "" ]] && p_err "no input string" && return 1
	(( ${#charlist64_1_v2[@]} < 64 )) && p_err "charlist64-arrays not defined" && return 1
	input_str="$1"
	mpm_decoded_arr=()
	for((i=0; i<${#input_str}; i++)); do
		j=0
		while [[ "${input_str:i:1}" != "${base64_charset[j]}" ]] && (( j < 64 )); do
			((j++))
		done
		if (( j < 62 )); then
			mpm_decoded_arr[${#mpm_decoded_arr[@]}]=${charlist64_1_v2[j]}
		elif (( j == 62 )); then
			(( i++ ))
			j=0
			while [[ "${input_str:i:1}" != "${base64_charset[j]}" ]] && (( j<64 )); do
				((j++))
			done
			if (( j > 63 )); then
				p_err "wrong encoding: '[${input_str:i-3:3}]${input_str:i:1}[${input_str:i+1:3}]'"
			fi
			mpm_decoded_arr[${#mpm_decoded_arr[@]}]=${charlist64_2_v2[j]}
		elif (( j == 63 )); then
			! decode_utf8 && p_err "can't decode utf8 char." && return 1
		else
			if [[ "${input_str:i:1}" == "=" ]]; then
				continue
			fi
			p_err "input was not base64 '${input_str:i:1}'"
			return 1
		fi
	done
	printf "%s" "${mpm_decoded_arr[@]}"
	printf "\n"
	return 0
}
