# read the passphrase to a variable using a tty to prohibit insecure piping
#
# ensure input is from the terminal, by letting input come from '/dev/tty':
# IFS= read -rs password < /dev/tty
# whithout '< /dev/tty' it would be possible to give the password like this:
#    echo "p4ssw0rd" | ./mpm.sh -e "4,13"
# which is visible by other processes and in history
# https://unix.stackexchange.com/questions/439497/is-there-a-way-to-pass-sensitive-data-in-bash-using-a-prompt-for-any-command/439575#439575
db_passphrase=""
read_passphrase(){
	printf "Enter database passphrase: "
	IFS= read -rs db_passphrase < /dev/tty
	echo
	return 0
}
