write_keyDB(){
	# backup keyDatabase
	f_date="$(date "+%y%m%d-%H%M%S")"
	bckp_keyDatabase="${keyDatabase_dir}/.${keyDatabase_filename}_${f_date}_bckp.enc"
	debug_keyDatabase="${keyDatabase_dir}/.${keyDatabase_filename}_${f_date}_size_err_debug.enc"
	oldDBsize=$(stat -f %z "$keyDatabase")
	bckp_keysAssignmentFile="${keyDatabase_dir}/.${keysAssignmentFilename}_${f_date}.enc"
	cp "$keyDatabase" "$bckp_keyDatabase"
	cp "$keysAssignmentFile" "$bckp_keysAssignmentFile"
	debugMsg "bckp_keyDatabase: '$bckp_keyDatabase'"

	get_iphrArrMD5
	iphrArray[${#iphrArray[@]}]=$iphrArrMD5

	echo "Writing to Key Database"
	(( ! iphrArray_isDecrypted )) && read_passphrase
	! ( openssl enc -e -aes-128-ctr -pbkdf2 -S ${keyDatabaseSalt} -pass stdin -out "$keyDatabase" -in <(printf "%s" ${iphrArray[@]} | xxd -p -r) ) <<< "$db_passphrase"  \
		&& mv "$bckp_keyDatabase" "$keyDatabase"   \
		&& p_err "openssl error. Key database not written."       \
		&& return 1
	# write keysAssignmentFile
	! ( openssl enc -e -aes-128-ctr -pbkdf2 -pass stdin -out "$keysAssignmentFile" -in <(printf "%s\n" "${keysAssignmentList}") ) <<< "$db_passphrase"  \
		&& mv "$bckp_keysAssignmentFile" "$keysAssignmentFile"   \
		&& p_err "openssl error. keysAssignmentFile not written."       \
		&& return 1

	newDBsize=$(stat -f %z "$keyDatabase")
	if (( newDBsize <= oldDBsize )); then
		cp "$keyDatabase" "$debug_keyDatabase" 
		p_err "Size error. Key Database not written."                \
		      "Investigate debug_keyDatabase. Size differences:"     \
		      "bckp_keyDatabase:" "$(ls -la "$bckp_keyDatabase")"    \
		      "debug_keyDatabase:" "$(ls -la "$debug_keyDatabase")"
		debugMsg "array is" "$(printf "%s\n" ${iphrArray[0]}; printf "\t%s\n" ${iphrArray[@]:1})"
		mv "$bckp_keyDatabase" "$keyDatabase"
		return 2
	fi

	rm "$bckp_keyDatabase"
	rm "$bckp_keysAssignmentFile"

	debugMsg "iphrArray:" \
	         "$(for (( i=0; i<${#iphrArray[@]}; i++ )); do
	         		(( i>0 )) && printf "\t"
	         		printf "%s\n" ${iphrArray[i]}
	         done)"
	# for interactive mode, remove md5 sum from array for decoding, or next write
	unset iphrArray[${#iphrArray[@]}-1]
	
	return 0
}

write_example_db(){
	example_arr=( 82e61fa02b004d1f0161fa02a08605b16e6e c158d83400e2207eea5c037d709440104104 42fb56106011451451451451451451451451 01508050ca029f70230a42461c04d2001082 01575f75f022eb410b2c037d7091c0104104 81575f75f022eb410b2c037d7091c0104104 42f641c03011451451451451451451451451  82e61fa02b004d1f0161fa02a08605b16e6e c158d83400e2207eea5c037d709440104104 42fb56106011451451451451451451451451 02b2da00e3407ae723c57009249249249249 )
	example_arr[${#a[@]}]=$(printf "%s\n" ${example_arr[@]} | md5 -q)
	! ( printf "%s" ${example_arr[@]} | xxd -p -r | openssl enc -e -aes-128-ctr -pbkdf2 > example_DB.enc ) && p_err "error while writing example_DB" && return 2
}
