#! /usr/local/bin/python3

# read/add/edit JSON attribute value pairs to a given JSON file
# example call for empty JSON file (containing only '{}'):
#
#   python3 edit_json.py example.json something "is very cool"
#

import sys, json

# get args or print usage
try:
	file_arg=sys.argv[1]
	JSON_attribute=sys.argv[2]
except:
	print("read / edit / add JSON attribute-value pairs to a given JSON file")
	print("usage:", sys.argv[0], "<JSON file> <attribute> [<value_to_write>]")
	quit()

if len(sys.argv) == 4:
	JSON_value=sys.argv[3]
	write_JSON = 1
else:
	write_JSON = 0

# open file for reading JSON
try:
	f = open(file_arg, "r")
except:
	print("File not found: '", file_arg, "'", sep="") 
	quit()

try:
	json_data = json.loads(f.read())
except:
	print("[error] File seems to be broken JSON")
	quit()

# close file
f.close()

# open file again for writing
if write_JSON:
	try:
		f = open(file_arg, "w")
	except:
		print("File not found: '", file_arg, "'", sep="") 
		quit()

	# print if changed
	# try:
	# 	print("Changed value: '", json_data[JSON_attribute], "'", " to:", sep="")
	# except:
	# 	# ignore error if JSON_attribute is not present
	# 	pass

	# prepare given JSON values
	json_data[JSON_attribute] = JSON_value

	# write JSON to file
	json.dump(json_data, f, indent=4)

	# close file
	f.close()

try:
	print(json_data[JSON_attribute])
except:
	print("[error]: No such value '", JSON_attribute, "'", sep="")
