encoding_format_date="dd.mm.yy <word number>"
about_message="Manual Password Manager


   Store passphrases indirectly combined with manual notes needed to decode.
   
   To store a passphrase, give information on which date it is noted.
   Multiple dates - when parts of the passphrase are written down -
   can be used to split the passphrase. This is to note credentials as 
   cutted pieces where information how to reassemble is stored here
   without the actual passphrase parts.
   
   To use other methods than the date/charnum method, see the -m option.
   
   Storage is a database using a homebrewn six bit words encoding (hexades).
   The database is rsa encrypted after encoding (using openssl).
   
   The key database is stored in:
       '$keyDatabase'
   Information to assign each stored Passphrase is also encrypted and stored in:
       '$keysAssignmentFile'
"

options="Options
   
   <keyID>
      Decode Indirect Passphrase (IPHR) with given
      Key ID.
      Indirect Passphrase is derived from encrypted
      Database. Decryption will prompt for passphrase
      input.
      IPHR can also be given directly (see -d option).
   
   -e, --encode
      Encode Indirect Passphrase. 
      Prompts for interactive input, as commandline input
      is stored in history file.
      Method to encode defaults to date/charnum.
      Use -m option to choose different method.
   
      indirect passphrase
         Has to be wellformed specified by the Method.
         
      date/charnum Method (default)
         The format has to be comma separated elements
            '<element>, ...,<element>'
         
         Elements are either dates, or chars
         
         Dates:
         Days with word count given in the format
            '$encoding_format_date'
         With <word number> in range -128 to 127 and not 0.
         Give word number if word appears in a text, and
         '1' otherwise.
         
         Chars:
         Characters given as a number in the range 1-63
            <number>
   
         Example
            \"13.12.23 5, 23.05.12 -12, 42, 17\"
   
      charlist64 (special case Date Method)
         Same as Date Method, but only chars.
         Example
            \"23, 42, 15, 2, 19, 60\"
   
      XOR charlist64
         Can be used to backup all passphrases indirectly on one paper
         with a copy of encrypted database (e.g. as a QR code).

         Type the passphrase (or any string) directly to be stored.

         Input is not an indirect passphrase this time, but
         will be stored indirectly as an encrypted string, XORed
         with a random key (generated by 'openssl rand').
         
         Write down the keys XOR string for decoding (and
         decryption in this case!). It's shown afterwards.
         Without this key decoding / decryption is impossible.
         
         ASCII and some UTF8 chars usable. No fully UTF8 support
         implemented yet.
         See file 'charlist64_list_definitions.sh' for supported
         characters.
         
         Use only on a trusted machine!
         Although only indirect passphrase is stored, the passphrase
         can be stolen on input by a keylogger or from memory.
   
   -i, --interactive
      use interactive mode for encoding and decoding.
   
   -m, --method <method ID>
      Specify other method than default 'date/charnum' for encoding.
   
      Method IDs are
         1  date/charnum    (default)
         2  XOR_charlist64
   
   -d, --direct <IPHR>
      Decode given <IPHR>, not one from the Database.
      <IPHR> can be given as one of the following:
      
         36 hex chars (with no prefix)
	 
         octal number (with the prefix '0o')
      
      If given as octal, use an even number of digits (to get
      hexades), up to 48 digits (24 hexades, equals 18 Bytes).

      Space grouping of the <IPHR> argument is allowed if in quotes.
   
   -cdb, --choose-database)
      Pick the database file

   -dbg, --debug
      Turn on debug messages

   -v|--version)
      Output version.
   
   -h, --help
      Print this help message.


When in interactive mode, leave out the leading '-'.
E.g. get this help by 'h' or '-help'.


Version:  $version"

optlist(){
	if (( !opt_interactive )); then
		echo ; echo
		echo "$about_message"
		echo
	fi
	echo "$options"
	if (( opt_interactive )); then
		echo
		echo "(Hit any key to continue)"
		read -n 1 answer
	fi
}
